/**
 * erwin - really simple html editor
 * Copyright (C)      1999 David Vogler
 * Copyright (C) 1999-2004 Adrian Reber
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: erwinfunctions.h,v 1.20 2004/07/03 20:14:25 erwin Exp $
 *
 * $Author: erwin $
 * 
 * Description: a lot of functions
 *
 * $Log: erwinfunctions.h,v $
 * Revision 1.20  2004/07/03 20:14:25  erwin
 * commit
 *
 * Revision 1.19  2004/06/27 17:48:47  erwin
 * * applied changes from erwinfunctions.c
 *
 *
 */

#ifndef ERWIN_FUNCTIONS_H
#define ERWIN_FUNCTIONS_H

#include "erwindef.h"

#include <config.h>

#ifdef USE_GTKHTML
#include <libgtkhtml/gtkhtml.h>
#endif				/* USE_GTKHTML */

/* All erwinfunctions.c prototypes */

GtkTextBuffer *get_text_buffer();
void copy_to_clipboard(GtkWidget *);
void cut_to_clipboard(GtkWidget *);
void paste_from_clipboard(GtkWidget *);
void insert_text(char *, gint);
void img_functions(GtkWidget *);
void body_img_function(GtkWidget *);
void file_ok_sel(GtkWidget *, GtkFileSelection *);
gint move_cursor(gint, ErwinCursor);
struct change test_selection();
void insert_text_around(struct change, char *, gint);
void destroy_message(GtkWidget *);
gint delete_event(GtkWidget *, GdkEvent *, gpointer);
gboolean quit_program();
void really_quit_program();
void get_value_1(GtkWidget *, GtkWidget *);
void get_value_2(GtkWidget *, GtkWidget *);
void destroy_table_wizard(GtkWidget *);
void find_entry_changed(GtkWidget *);
void _open_file_ok(const gchar * filename);
void open_file_ok(GtkWidget *, GtkFileSelection *);

void save_file_ok(struct document *);
void new_file();
void close_message_dialog(GtkWidget *, gpointer);
void ungrab_message(GtkWidget *, gpointer);
void display_dialog(gchar *, gchar *);
void find_function(GtkWidget *, gpointer);
gint look_for_string(GtkTextIter *);
GtkWidget *entry_in_frame(gchar *, struct frame_entry *);
void body_functions();
void legal();
void set_title_name();
void ok_body_dialog(GtkWidget *, gpointer);
void make_body_options_string(GString *, gchar *, struct frame_entry *);
gboolean does_file_exist(const gchar *);
gboolean is_file_readonly(const gchar *);
gboolean is_file_a_directory(const gchar *);
void insert_symmetric_tag(gchar *);
void body_img_file_ok_sel(GtkWidget *, GtkWidget *);
void href_function_ok(GtkWidget *, gpointer);
GtkWidget *combo_in_frame(gchar *, struct frame_combo *, GList *);
void font_function_ok(GtkWidget *, gpointer);
void switch_page(GtkWidget * widget, GtkNotebookPage *, gint, gpointer);
void close_current_file();
void quit_program_from_menu();
gboolean close_file(GtkWidget *, gpointer);
void switch_html_page();
void really_close_file();
void close_ask_no();
void close_ask_yes(struct document *);

void focus_text_view();
gboolean rendered();
void buffer_changed(GtkTextBuffer * textbuffer, gpointer user_data);
void clean_selected();
void add_to_statusbar(gchar *, gboolean);
void update_statistic(GtkTextBuffer *);
void close_tag();
GtkSignalFunc drop_file(GtkWidget *, GdkDragContext *, gint, gint, GtkSelectionData *, guint, guint,
    gpointer);
void make_dropable(GtkTextView *);
void set_view_font(GtkTextView *);

#ifdef USE_GTKHTML
void view_html();
HtmlDocument *fill_html_document(HtmlDocument * html_document);
#endif				/* USE_GTKHTML */
void put_in_scrollbar(struct document *);
void make_highlighted_text_view(struct document *, GtkTextBuffer *);
#endif				/* ERWIN_FUNCTIONS_H */
